import Vapor
import HTTP

final class GroupController {

  func addRoutes(drop: Droplet) {
    let basic = drop.grouped("groups")
    basic.get(handler: index)
    basic.post(handler: create)
    basic.delete(Group.self, handler: delete)
    basic.get(Group.self, "users", handler: tilusersIndex)
  }

  func index(request: Request) throws -> ResponseRepresentable {
    return try JSON(node: Group.all().makeNode())
  }
  
  func create(request: Request) throws -> ResponseRepresentable {
    var group = try request.group()
    try group.save()
    return group
  }
  
  func delete(request: Request, group: Group) throws -> ResponseRepresentable {
    try group.delete()
    return JSON([:])
  }
  
  func tilusersIndex(request: Request, group: Group) throws -> ResponseRepresentable {
    let tilusers = try group.tilusers()
    return try JSON (node: tilusers.makeNode())
  }

}

extension Request {
  func group() throws -> Group {
    guard let json = json else { throw Abort.badRequest }
    return try Group(node: json)
  }
}
