import Vapor
import VaporPostgreSQL
import Fluent

let drop = Droplet()
try drop.addProvider(VaporPostgreSQL.Provider)
drop.preparations += Acronym.self
drop.preparations += TILUser.self
drop.preparations += Group.self
drop.preparations += Pivot<TILUser, Group>.self

(drop.view as? LeafRenderer)?.stem.cache = nil

let basic = BasicController()
basic.addRoutes(drop: drop)

let acronyms = AcronymsController()
acronyms.addRoutes(drop: drop)

let tilusers = TILUserController()
tilusers.addRoutes(drop: drop)

let groups = GroupController()
groups.addRoutes(drop: drop)

let controller = TILController()
controller.addRoutes(drop: drop)

drop.run()
